
; Starfield
; Author : Matthias Alles
; (c) 2007

	.text

	nop
	nop

clr_scr:
	move.w r0, #0
	move.w r1, #0
	move.w r2, #(320*200)
	nop

	do r2,delete_loop
	str.fb (r0)+,r1						; set old pixel to black!
	nop

delete_loop:


prog_start:
	move.w r0, #300
	move.w r1, #(_stars-_datamem_start)	; load address to stars
	move.w r7, #pixel_addresses         ; get pointer to the actually drawn pixels

	do r0,draw_stars					; hardware loop to draw each star
; do not clear
; r1, r7

; LOADING OF STAR
	ld r2,(r1)+							; load x of star
	ld r3,(r1)+							; load y of star


; ROTATION
	move.w r0, #angle
	ld r4,(r0) 							; get current angle
	move.w r0, #sintab					; address to sin
	add r0,r4,r0						; pointer to sin_phi
	ld r4,(r0)							; sin_phi

	move.w r0, #angle
	ld r5,(r0) 							; get current angle
	move.w r0, #(sintab+64)				; address to cos
	add r0,r5,r0						; pointer to cos_phi
	ld r5,(r0)							; cos_phi

; r2 = x
; r3 = y
; r4 = sin_phi
; r5 = cos_phi

	mul.f r6,r2,r5						; old_x * cos_phi
	mul.f r0,r3,r4						; old_y * sin_phi
	sub r0,r6,r0						; new_x = old_x * cos_phi - old_y * sin_phi

	mul.f r5,r3,r5						; old_y * cos_phi
	mul.f r6,r2,r4						; old_x * sin_phi
	add r3,r5,r6						; new_y = old_y * cos_phi + old_x * sin_phi
	and r2,r0,r0						; copy new_x to r2

; r2 = new_x
; r3 = new_y

	ld r4,(r1)							; load z of star
	move.w r6, #64						; z offset
	add r4,r4,r6						; z = z + offset

; PROJECTION

	move.w r0, #(_divtab-_datamem_start); load base address of divtab
	add r5,r4,r0						; get address to divtab entry
	ld r6,(r5)							; get 1/z
	move.w r0, #11						; Scale x and y
	mul r2,r2,r0
	mul r3,r3,r0
	mul.f r2,r2,r6						; calculate x/z
	mul.f r3,r3,r6						; calculate y/z

; MOVING IN Z-DIRECTION

	move.w r6, #3						; z offset
	sub r4,r4,r6						; z = z + offset
	move.w r6, #64						; z offset
	sub r4,r4,r6						; z = z + offset
	move.w r6, #0x1FF					; z modulo
	and r4,r4,r6						; z = z & 511 = make wrap of z 
	str (r1)+,r4						; store new z


; CLIPPING OF PIXELS
	move.w r6, #159						; x-width
	add r5,r2,r6						; x+160
	jneg clear_star						; negative? => don't draw the star!
	sub r5,r2,r6						; x-160
	jpos clear_star						; positive? => don't draw the star!

	move.w r6, #99						; y-width
	add r5,r3,r6						; y+100
	jneg clear_star						; negative? => don't draw the star!
	sub r5,r3,r6						; y-100
	jpos clear_star						; positive? => don't draw the star!


; DRAW TO SCREEN

	move.w r6, #320
	move.w r5, #(160+100*320)
	mul r6,r3,r6						; y * 320
	add r6,r2,r6						; y * 320 + x = screen address
	add r6,r5,r6						; screen address + middle of screen

	move.w r5, #0x0000
	ld r2,(r7)							; get the screen address of the old pixel
	str.fb (r2),r5						; set old pixel to black!

	move.w r5, #0xFFFF
	str.fb (r6),r5						; use white as color for pixel
	str (r7)+,r6						; remember the screen address for the next time

dont_draw_star:

	nop

draw_stars:
	nop
	move.w r0, #0xDFFF
	move.w r4, #1
	nop
slow_down_loop:

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	sub r0,r0,r4						; decrease loop counter
	nop
	jne slow_down_loop
	nop
	

; increase angle for next time
	move.w r0, #angle
	ld r4,(r0) 							; get current angle
	move.w r5, #1
	add r5,r5,r4						; new_angle = old_angle + 3
	move.w r4, #0xFF					; limit angle to 255
	and r5,r4,r5
	str (r0), r5						; write back new angle
	nop
	jmp prog_start
	nop


clear_star: 
	nop
	move.w r5, #0x0000
	ld r0,(r7)							; get the screen address of the old pixel and don't remember any new screen address
	str.fb (r0),r5						; set old pixel to black!
	str (r7)+,r5						; Clear the screen address
	nop
	jmp dont_draw_star
	nop
	nop


	.data
_datamem_start:

angle:
	.short 0x0000

pixel_addresses:
	.AREPEAT (511)
	.short 0x0000
	.AENDR

num_points .set 300

; SOME STARS
_stars:
	.INCLUDE "stars.asm"

; INCLUDE SINCOS TABLE (256 Entries)
sintab:
	.INCLUDE "sincostab.asm"

; GENERATE DIVISION TABLE (512 Entries)
_divtab:
	.int 0
i	.ASSIGNA 1
	
	.AREPEAT (511)
	.short (0x7FFF/i)
i	.ASSIGNA (i+1)
	.AENDR

